﻿
/**
 * 98指南针 WSS服务 JSAPI
 * Authoer Linyee
 * Write at 2021-01-13
 * 
 * 示例：znzwebsocket.open({wssurl:'',onopen:function () { },onclose:function () { },onerror:function () { },onmessage:function () { }});
 * 
 * */

function znz98_wss_sdk() {
    var wss = this;
    var defutl_options_fun = function () {
        return {
            wssurl: '',
            onopen: function () { },
            onclose: function () { },
            onerror: function () { },
            onmessage: function () { },
        }
    };
    var defutl_options = new defutl_options_fun();

    //生成从minNum到maxNum的随机数
    this.randomNum =function(minNum, maxNum) {
        switch (arguments.length) {
            case 1:
                return parseInt(Math.random() * minNum + 1, 10);
                break;
            case 2:
                return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
                break;
            default:
                return 0;
                break;
        }
    }

    this.newId=function generateUUID() {
        var d = new Date().getTime();
        if (window.performance && typeof window.performance.now === "function") {
            d += performance.now(); //use high-precision timer if available
        }
        var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
        return uuid;
    }

    this.getJson = function (opt) {
        var http;
        if (window.XMLHttpRequest) {
            http = new XMLHttpRequest();
        } else if (window.ActiveXObject) {
            http = new window.ActiveXObject();
        } else {
            console.warn("请升级至最新版本的浏览器");
        }
        if (http != null) {
            http.open("GET", opt.url, true);
            http.send(null);
            http.onreadystatechange = function () {
                if (http.readyState == 4 && http.status == 200) {
                    if (typeof (opt.success) === 'function') opt.success(JSON.parse(http.responseText));
                } else if (http.readyState == 4) {
                    if (typeof (opt.error) === 'function') opt.error(JSON.parse(http.responseText));
                }
            };
        } else {
            console.warn("请升级至最新版本的浏览器");
        }
    }

    var dtnow = new Date();
    this.year = dtnow.getFullYear();

    /**
     * 指南针 websocket
     * @param {any} options 参数
     */
    class znz98websocket
    {
        /**
         * 指南针 websocket
         * @param {any} options 参数
         */
        constructor(options){
            var ws = this;
            var mq = [];
            var receivedmq = [];
            var mi = 0;
            var settings = {};
            var opttype = typeof options;
            if (opttype === 'string') {
                settings.wssurl = options;
            }
            else if (opttype === "object") {
                Object.keys(defutl_options).forEach(function (v, i, a) {
                    settings[v] = options[v] || defutl_options[v];
                });
            }
            else if (opttype === "function") {
                var opt = options.apply(this, new defutl_options_fun())
                Object.keys(defutl_options).forEach(function (v, i, a) {
                    settings[v] = opt[v] || defutl_options[v];
                });
            }

            var socket = new WebSocket(settings.wssurl);
            var startsend = function () {
                if (mq.length > 0) {
                    var dtime = new Date().getTime();
                    var d = mq[0];
                    if (d.sended && (dtime - d.lasttime) < 5000) {
                        return;
                    }
                    socket.send(JSON.stringify(d));
                    d.sended = true;
                    d.lasttime = dtime;
                    if (d.mt == 7) mq.shift();
                }
            };
            var sendtimer = setInterval(startsend, 1000);

            var startonmessage = function () {
                if (typeof ws.onmessage === "function") {
                    settings.onmessage = ws.onmessage;
                }
                while (typeof settings.onmessage === "function" && receivedmq.length > 0) {
                    var dtime = new Date().getTime();
                    var d = receivedmq[0];
                    if (d.sended && (dtime - d.lasttime) < 5000) {
                        return;
                    }
                    var result = settings.onmessage.apply(socket, [{ data:d.mt?d.m:d }]);
                    d.sended = true;
                    d.lasttime = dtime;
                    if (result != false) {
                        d = receivedmq.shift();
                    }
                }
            };
            var messagetimer = setInterval(startonmessage, 1000);

            var reconnect = function () {
                socket = new WebSocket(settings.wssurl);
            }
            var connecttimer = setInterval(reconnect, 3000);

            socket.onopen = function (event) {
                ws.readyState = socket.readyState;
                clearInterval(connecttimer);
                if (typeof ws.onopen === "function") {
                    settings.onopen = ws.onopen;
                }
                if (typeof settings.onopen === "function") {
                    settings.onopen.apply(socket, arguments);
                }
            };
            socket.onclose = function (event) {
                ws.readyState = socket.readyState;
                if (typeof ws.onclose === "function") {
                    settings.onclose = ws.onclose;
                }
                if (typeof settings.onclose === "function") {
                    settings.onclose.apply(socket, arguments);
                }
                if(event.code==1000)return;
                if(connecttimer)clearInterval(connecttimer)
                connecttimer = clearInterval(reconnect, 3000);

            };
            socket.onerror = function (event) {
                ws.readyState = socket.readyState;
                if (typeof ws.onerror === "function") {
                    settings.onerror = ws.onerror;
                }
                if (typeof settings.onerror === "function") {
                    settings.onerror.apply(socket, arguments);
                }
            };
            socket.onmessage = function (event) {
                console.log('recived',event.data)
                ws.readyState = socket.readyState;
                var data = JSON.parse(event.data);

                if (data.mt == 7 && mq.length > 0) {
                    var d = mq[0];
                    if (d.mi == data.mi || d.imi == data.imi) {
                        mq.shift();
                        startsend();
                    }
                    return;//应答消息
                }
                if(data.rspdata?.heartBeat){
                    return;//跳过心跳
                }
                ws.send(1, 7, data.mi, data.imi);
                if (data.mt == 6) {
                    ws.clientid = data.m;
                    return;
                }

                receivedmq.push(data);
                startonmessage();
            };
            /**
             * 发送消息
             * @param {string} data 内容
             * @param {number} mt 类别 默认为2
             * @param {number} _mi 消息id
             * @param {unique} _imi id
             * @param {boolean} nosave 告诉服务端是否不保存，默认保存
             */
            ws.send = function (msg, mt, _mi, _imi, nosave) {
                var d = { mt: mt || 2, m: msg, mi: _mi || ++mi };
                if (d.mt == 7) {
                    if (_imi) d.imi = _imi;
                    socket.send(JSON.stringify(d));
                } else {
                    d.imi = _imi || (mt != 7 && nosave != true ? wss.newId() : null);
                    mq.push(d);
                    startsend();
                }
            };
            /**
             * 关闭连接
             * @param {any} code 代码
             * @param {any} reason 原因
             */
            ws.close = function (code, reason) {
                socket.close(code, reason);
                clearInterval(sendtimer);
                clearInterval(messagetimer);
            }
        }
    }


/**
 * 打开websocket
 * @param {any} options
 */
    this.open = function (options) { return new znz98websocket(options);};
    return this;
}
/**
 * 98指南针 wss sdk
 * */
var znz98ws = new znz98_wss_sdk();

